Name:           blesh
Version:        0.4.0~devel3
Release:        2%{?dist}
Summary:        Command line editor written in pure Bash which replaces the default GNU Readline

# contrib/ is MIT
License:        BSD-3-Clause AND MIT
URL:            https://github.com/akinomyoga/ble.sh
# the official tarball does not have Makefile and other files we need
Source0:        https://github.com/akinomyoga/ble.sh/releases/download/v0.4.0-devel3/ble-0.4.0-devel3.tar.xz
Source1:        README-Fedora.txt
BuildArch:      noarch

#BuildRequires:  
#Requires:       

%description
Enhanced Bash Line Editor with features like:
* Syntax highlighting: Highlight command lines input by users as in fish and
  zsh-syntax-highlighting. Unlike the simple highlighting in
  zsh-syntax-highlighting, ble.sh performs syntactic analysis to enable the
  correct highlighting of complex structures such as nested command
  substitutions, multiple here documents, etc. Highlighting colors and styles
  are fully configurable.
* Enhanced completion: Extend completion by
  syntax-aware completion, completion with quotes and parameter expansions in
  prefix texts, ambiguous candidate generation, etc. Also, menu-complete
  supports the selection of candidates in the menu (candidate list) by cursor
  keys, TAB, and S-TAB. The feature auto-complete supports the automatic
  suggestion of completed texts as in fish and zsh-autosuggestions (with Bash
  4.0+). The feature menu-filter integrates automatic filtering of candidates
  into menu completion (with Bash 4.0+). There are other functionalities such
  as dabbrev and sabbrev like zsh abbreviations or zsh-abbr.
* Vim editing mode: Enhance readline's vi editing mode available with set -o vi.
  Vim editing mode supports various vim modes such as char/line/block
  visual/select mode, replace mode, command mode, operator pending mode as
  well as insert mode and normal mode. Vim editing mode supports various
  operators, text objects, registers, keyboard macros, marks, etc. It also
  provides vim-surround as an option.
* Other interesting features include
  status line, history share, right prompt, transient prompt, xterm title,
  etc.


%prep
%autosetup -n ble-0.4.0-devel3


%build


%install
mkdir -p %{buildroot}%{_libexecdir}/blesh/
cp -a * %{buildroot}%{_libexecdir}/blesh/

mkdir -p %{buildroot}%{_pkgdocdir}
install -m 644 -p %{SOURCE1} %{buildroot}%{_pkgdocdir}

# downstream fixes
chmod a+x %{buildroot}%{_libexecdir}/blesh/lib/benchmark.ksh
for file in bash-preexec.bash fzf-completion.bash fzf-git.bash fzf-initialize.bash fzf-key-bindings.bash; do
  ln -sf "integration/$file" "%{buildroot}%{_libexecdir}/blesh/contrib/$file"
done

%files
%doc %{_pkgdocdir}
%{_libexecdir}/blesh


%changelog
* Fri Feb 16 2024 msuchy <msuchy@redhat.com> 0.4.0~devel3-2
- initial release
